#include <windows.h>
#include "Hookdata.h"

THookData *HookData = NULL; //  
//  ,   
static HANDLE hFileMap = NULL;
//----     -----
static SECURITY_ATTRIBUTES sa;
static char ForSecurityDescriptor[SECURITY_DESCRIPTOR_MIN_LENGTH];

static SECURITY_ATTRIBUTES * psa;
static SECURITY_DESCRIPTOR * psd;

void WINAPI DeleteParamData();
BOOL WINAPI CreateParamData();

//---------------------------------------------------------------------------
//
//  FUNCTION: GetLastErrorText
//
//  PURPOSE: copies error message text to string
//
//  PARAMETERS:
//    lpszBuf - destination buffer
//    dwSize - size of buffer
//
//  RETURN VALUE:
//    destination buffer
//
//  COMMENTS:
//
LPTSTR GetLastErrorText( LPTSTR lpszBuf, DWORD dwSize )
{
    DWORD dwRet;
    LPTSTR lpszTemp = NULL;

    dwRet = FormatMessage( FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM |FORMAT_MESSAGE_ARGUMENT_ARRAY,
                           NULL,
                           GetLastError(),
                           LANG_NEUTRAL,
                           (LPTSTR)&lpszTemp,
                           0,
                           NULL );

    // supplied buffer is not long enough
    if ( !dwRet || ( (long)dwSize < (long)dwRet+14 ) )
        lpszBuf[0] = TEXT('\0');
    else
    {
        lpszTemp[lstrlen(lpszTemp)-2] = TEXT('\0');  //remove cr and newline character
        wsprintf( lpszBuf, TEXT("%s (0x%x)"), lpszTemp, GetLastError() );
    }

    if ( lpszTemp )
        LocalFree((HLOCAL) lpszTemp );

    return lpszBuf;
}

//---------------------------------------------------------------------------
            // Set up a security descriptor with a NULL DACL, to allow all
            // access to an object.  This is used if we need to create the
            // mutex and shared memory section.  Failure to do this is a
            // fatal error.
BOOL WINAPI CreateSecurity()
{
            psa = &sa;
            psd = (SECURITY_DESCRIPTOR *)ForSecurityDescriptor;

            if (!InitializeSecurityDescriptor(psd, SECURITY_DESCRIPTOR_REVISION))
            {
                return FALSE;
            }
            else if (!SetSecurityDescriptorDacl(psd, TRUE, (PACL) NULL, FALSE))
            {
                return FALSE;
            }
            else
            {
                psa->nLength = sizeof(*psa);
                psa->lpSecurityDescriptor = psd;
                psa->bInheritHandle = TRUE;
            }
    return TRUE;
 }
//---------------------------------------------------------------------------
void WINAPI DeleteParamData()
{

   if(HookData)UnmapViewOfFile ((LPVOID)HookData);
   HookData=NULL;
   if(hFileMap)CloseHandle (hFileMap);
   hFileMap=NULL;
}
//---------------------------------------------------------------------------
BOOL WINAPI CreateParamData()
{
  BOOL fInit, fIgnore;
  char buf[40];

  hFileMap=NULL; // handle to file mapping
  HookData=NULL; //    
  // SECURITY_DESCRIPTOR
  if(!CreateSecurity())goto OnError;
  //       
  hFileMap = CreateFileMapping (
                INVALID_HANDLE_VALUE, // use paging file
                &sa,                 // no security attributes
                PAGE_READWRITE,       // read/write access
                0,                    // size: high 32-bits
                sizeof (THookData),   // size: low 32-bits
                HOOK_SHARED_DATA); // name of map object
  if (!hFileMap)goto OnError;//     
  // The first process to attach initializes memory.
   fInit = (GetLastError() != ERROR_ALREADY_EXISTS);
  // Get a pointer to the file-mapped shared memory.
  HookData = (THookData *)MapViewOfFile(hFileMap,FILE_MAP_ALL_ACCESS,0,0,0);
  if (!HookData)goto OnError1;
  // Initialize memory if this is the first process.
  if (fInit)
  {
   char *ptr=(char *)HookData;
   for(int i=0; i < sizeof(THookData); i++)*ptr++=0;
   //ZeroMemory(HookData,sizeof(THookData));
  }
  return TRUE;
OnError:
  MessageBox(NULL,GetLastErrorText( (LPTSTR)buf, (DWORD)40 ),"HookDll",MB_OK);
  goto onexit;
OnError1:
  MessageBox(NULL,"HookData==NULL","HookDll",MB_OK);
  goto onexit;
OnError2:
  MessageBox(NULL,"Error from InstallHook","HookDll",MB_OK);
  goto onexit;
onexit:
  DeleteParamData();
  return FALSE;
}
//---------------------------------------------------------------------------

