//---------------------------------------------------------------------------
#include <windows.h>

#pragma hdrstop

#include "Hookdata.h"


//---------------------------------------------------------------------------
HINSTANCE hDllInstance = NULL;// 
extern "C" BOOL WINAPI _export InstallHook(HWND hWnd,UINT message);
extern "C" BOOL WINAPI _export RemoveHook();

extern THookData *HookData; //  
extern void WINAPI DeleteParamData();
extern BOOL WINAPI CreateParamData();

//---------------------------------------------------------------------------
HWND GetWindowFromPoint(POINT &pointw)
{
 POINT point=pointw;
 HWND hWnd = WindowFromPoint(point);
 // WindowFromPoint() returns handle to the parent
 // if currently browsing on a child control that is
 // hidden/disabled/transparent
 for(;;)
 {
   ScreenToClient(hWnd, &point);
   HWND hWndChild = ChildWindowFromPoint(hWnd, point);
   ClientToScreen(hWnd, &point);
   if(hWndChild && hWndChild != hWnd)
   {
     hWnd = hWndChild;
   }
   else
      break;
 }
 return hWnd;
}
//---------------------------------------------------------------------------
LRESULT CALLBACK MouseProc(int nCode, WPARAM wParam, LPARAM lParam)
{
    if (nCode < 0)
        return CallNextHookEx(HookData->hHook, nCode, wParam, lParam);
    switch(wParam)
    {
       case WM_MOUSEMOVE:
       case WM_NCMOUSEMOVE:
       case WM_LBUTTONDOWN:
       case WM_NCLBUTTONDOWN:
       case WM_LBUTTONUP:
       case WM_NCLBUTTONUP:
       case WM_RBUTTONDOWN:
       case WM_NCRBUTTONDOWN:
      DWORD  dwResult;
      POINT point;
      HWND hWnd,hWndParent,hWndOwner,h;
      LPMOUSEHOOKSTRUCT MouseHookParam = (MOUSEHOOKSTRUCT FAR *)lParam;
      point.x = (LONG)MouseHookParam->pt.x;
      point.y = (LONG)MouseHookParam->pt.y;

         hWnd=GetWindowFromPoint(point);
         hWndParent=hWnd;
         for(;;)
         {
          h=GetParent(hWndParent);
          if(!h)break;
          hWndParent=h;
         }
         //hWndOwner=GetWindow(hWndParent,GW_OWNER);
//         PostMessage(HookData->hWnd,HookData->message,(WPARAM)hWnd,(LPARAM)hWndParent);

         SendMessage(HookData->hWnd,HookData->message,(WPARAM)hWnd,(LPARAM)hWndParent);
    }
    return CallNextHookEx(HookData->hHook, nCode, wParam, lParam);
}

//---------------------------------------------------------------------------

BOOL WINAPI InstallHook(HWND hWnd,UINT message)
{
    if(HookData== NULL)return FALSE; // 
    if(HookData->hHook)return TRUE; // 
    HookData->hHook =
      SetWindowsHookEx(WH_MOUSE,(HOOKPROC)MouseProc,hDllInstance,0);
    if(HookData->hHook == NULL)return FALSE;
    HookData->hWnd=hWnd; //    
    HookData->message=message; //  
    return TRUE;
}
//---------------------------------------------------------------------------

BOOL WINAPI RemoveHook()
{
  if(HookData->hHook)UnhookWindowsHookEx(HookData->hHook);
  HookData->hHook=NULL;
  return TRUE;
}
//---------------------------------------------------------------------
#pragma argsused
BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fwdreason, LPVOID lpvReserved)
{
    switch (fwdreason)
    {
      case DLL_PROCESS_ATTACH :
           hDllInstance = hinstDLL;
           //       
          if(!CreateParamData())return 0;
            return 1;
        case DLL_PROCESS_DETACH :
           DeleteParamData();
            break;
    }
    return 1;
}
//---------------------------------------------------------------------------

